﻿using System;
using System.ComponentModel;
using GalaSoft.MvvmLight;
using System.Collections.Generic;

namespace Benday.UserGroupManager.Presentation
{
    public class ViewModelField<T> : ViewModelBase, INotifyPropertyChanged, IViewModelField<T>
    {
        public ViewModelField()
        {

        }

        public ViewModelField(T initialValue)
        {
            m_value = initialValue;
        }

        private T m_value;
        public T Value
        {
            get { return m_value; }
            set
            {
                if (EqualityComparer<T>.Default.Equals(m_value, value) == false)
                {
                    m_value = value;
                    base.RaisePropertyChanged("Value");
                }
            }
        }
        
        public override string ToString()
        {
            if (Value == null)
            {
                return String.Empty;
            }
            else
            {
                return Value.ToString();
            }
        }
    }
}
